/*
 * Problem    : museum
 * Author     : Daniel Neiter
 * Language   : C++
 * Compiler   : GCC 3.4.2
 * Algorithm  : Brutforce backtracking algo
 * Complexity : O(N!) 
 */

#include <cstdio>
#include <iostream>

using namespace std;

const char *infile="museum.dat";
const char *outfile="museum.sol";

const int maxN=50;

int n,mod;
int res;
int adj[maxN+1][maxN+1];
bool have_to[maxN+1];

void solve(int i) {
     if(i>n)res=(res+1)%mod;
     else {
          for(int j=1;j<=n;j++)
               if(adj[i][j]&&!have_to[j]) {
                    have_to[j]=true;
                    solve(i+1);
                    have_to[j]=false;
               }
     }
}

int main() {
     int i,a,b;
     FILE *ifs=fopen(infile,"r");
     FILE *ofs=fopen(outfile,"w");

     fscanf(ifs,"%d%d",&n,&mod);
     for(i=1;i<=n;i++) {
          fscanf(ifs,"%d%d",&a,&b);
          adj[a][b]=adj[b][a]=1;
          adj[i][i]=1;
     }

     solve(1);
     fprintf(ofs,"%d\n",res);

     fclose(ifs);
     fclose(ofs);
     return 0;
}
